#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>

#define PORT 3210 

#define MAX_WORDS 52429
#define MAX_WORD_LEN 100

int sendall(int sockfd, char * buf, int len);
int recvall(int sockfd, char * buf, int len);

char B[MAX_WORDS][MAX_WORD_LEN];

int main(void){

	int sockfd;
	struct sockaddr_in their_addr;

	int i = 0;

	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

	their_addr.sin_family = AF_INET;
	their_addr.sin_port = htons(PORT);
	their_addr.sin_addr.s_addr = inet_addr("150.140.186.106");
	memset(&(their_addr.sin_zero), '\0', 8);

	if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) == -1) {
		perror("connect");
		exit(1);
	}
	printf("Connected with %s\n", inet_ntoa(their_addr.sin_addr));

	for(i = 0 ; i < MAX_WORDS ; i++){
		if (recvall(sockfd, B[i], MAX_WORD_LEN) == -1)
			perror("recv");
	}

	for(i = 0 ; i < MAX_WORDS ; i++){
		if (sendall(sockfd, B[i], MAX_WORD_LEN) == -1)
			perror("send");
	}

	printf("Press enter to close connection\n");
	fflush(stdin);
	getchar();
	close(sockfd);
	return 0;
}


int sendall(int sockfd, char * buf, int len){

	int total = 0; // how many bytes we've sent
	int bytesleft = len; // how many we have left to send
	int n;

	while(total < len) {
		n = send(sockfd, buf+total, bytesleft, 0);
		if (n == -1) { break; }
		total += n;
		bytesleft -= n;
	}

	return n == -1 ? -1 : 0; // return -1 on failure, 0 on success
}


int recvall(int sockfd, char * buf, int len){

	int total = 0; // how many bytes we've received
	int bytesleft = len; // how many we have left to receive
	int n;

	while(total < len) {
		n = recv(sockfd, buf+total, bytesleft, 0);
		if (n == -1) { break; }
		total += n;
		bytesleft -= n;
	}
	

	return n == -1 ? -1 : 0; // return -1 on failure, 0 on success
}


